Attribute VB_Name = "Module2"
Option Explicit

Public xlDateiName As String
Public xlWS_Name As String

Public xlAppl As Object    ' As Excel.Application
Public xlApplLiefNicht As Boolean

Public xlWB As Object      ' As Excel.Workbook
Public xlWS As Object      ' As Excel.Worksheet

Sub Excel_verbinden(Datei, Sheet As String)
  Dim boolWBOffen As Boolean
  Dim wb As Object          ' As Excel.Workbook
  
  xlDateiName = Datei
  xlWS_Name = Sheet
  
'GetObject-Funktionsaufruf ohne erstes Argument gibt einen
'  Verweis auf eine Instanz der Anwendung zurck. Wenn die
'  Anwendung nicht ausgefhrt wird, tritt ein Fehler auf.

'Prfen, ob Excel ausgefhrt wird:
  On Error Resume Next
  Set xlAppl = GetObject(, "Excel.Application")
  If Err.Number <> 0 Then xlApplLiefNicht = True
  
  Err.Clear   ' Err-Objekt im Fehlerfall lschen
  
'Wenn Excel nicht ausgefhrt wird, Excel starten:
  If xlAppl Is Nothing Then
    Set xlAppl = CreateObject("Excel.Application")
  'Wenn ein Fehler aufgetreten ist...
    If Err.Number <> 0 Then
        MsgBox "Konnte keine Verbindung zu den Exceldaten herstellen !", vbOKOnly + vbCritical
    End If
  End If
  
'Prfen, ob Arbeitsmappe bereits offen ist:
  boolWBOffen = False
  If Not xlApplLiefNicht Then
    If xlAppl.Workbooks.Count > 0 Then
      For Each wb In xlAppl.Workbooks
        If LCase(wb.Name) = LCase(xlDateiName) Then
          'wb.Activate
          boolWBOffen = True
          Exit For
        End If
      Next
    End If
  End If
  
  On Error Resume Next
  
  If Not boolWBOffen Then
  'Wenn Arbeitsmappe nicht offen, ffnen und Verweis setzen:
    Err.Clear
    Set xlWB = xlAppl.Workbooks.Open( _
          FileName:=App.Path & "\" & xlDateiName)
  
  'Wenn ein Fehler aufgetreten ist...
    If Err.Number <> 0 Then
      MsgBox "Die Arbeitsmappe '" & xlDateiName & _
             "' konnte nicht geffnet werden !", _
             vbOKOnly + vbCritical
      If xlApplLiefNicht Then xlAppl.Application.Quit
      Set xlAppl = Nothing
    End If
  Else
  'Verweis setzen:
    Set xlWB = xlAppl.Workbooks(xlDateiName)
  End If

  On Error GoTo 0
   
  'Verweis auf Tabellenblatt setzen:
  Set xlWS = xlWB.Worksheets(xlWS_Name)
  
End Sub

Sub Excel_schliessen()
'Excel "aufrumen":
  On Error Resume Next
  If Not xlAppl Is Nothing Then
    If Not xlWB Is Nothing Then
    'Excel-Arbeitsmappe schliessen, hier OHNE speichern!!!
      xlWB.Close SaveChanges:=False
    'Verweise freigeben:
      Set xlWS = Nothing
      Set xlWB = Nothing
    End If
    
  'Wenn Excel nicht bereits ausgefhrt wurde, schliessen:
    If xlApplLiefNicht Then xlAppl.Application.Quit
  'Verweis freigeben:
    Set xlAppl = Nothing
  End If
End Sub


Sub Comboboxwerte_einlesen()
Dim Endwert As Integer
Dim i As Integer
Dim Listeneintrag As String

    
    Excel_verbinden "Passfeder.xls", "Passfederdaten"
    'Wellendurchmesser in Combo-Box fllen
    Endwert = xlWS.Cells(2, 7)
    frmHexProfile.Cmb_WD.Clear
    For i = 5 To Endwert + 4
        With frmHexProfile
            Listeneintrag = xlWS.Cells(i, 2)
            .Cmb_WD.AddItem (Listeneintrag)
        End With
    Next i
    'Passfederlngen in Combo-Box fllen
    Endwert = xlWS.Cells(2, 13)
    frmHexProfile.Cmb_PL.Clear
    For i = 5 To Endwert + 4
        With frmHexProfile
            Listeneintrag = xlWS.Cells(i, 11)
            .Cmb_PL.AddItem (Listeneintrag)
        End With
    Next i
    'Excel_schliessen
    
End Sub




